#include "stdafx.h"
#include "resource.h"
#include <stdio.h>


CDeepFish::CDeepFish( UINT a, UINT b, UINT c )
{
//TCHAR str[1000];
//wsprintf( str, "CDeepFish( %u, %u, %u )", a, b, c );
//_debug( str );
	if( a + b + c == 0U ) a = 1U;

	m_a = a;
	m_b = b;
	m_c = c;
	m_dwMin = Min( a, b, c );
	m_dwMid = Mid( a, b, c );
	m_dwMax = Max( a, b, c );

	m_dwSize = ( m_a + 1 ) * ( m_b + 1 ) * ( m_c + 1 );
	m_lpdwIKnow = new DWORD[ m_dwSize ];
	memset( m_lpdwIKnow, 0, m_dwSize * sizeof( DWORD ) );
	UINT i, j, k;
	for( i = 0; i <= m_dwMin; i++ )
	{
		for( j = i; j <= m_dwMid; j++ )
		{
			for( k = j; k <= m_dwMax; k++ )
			{
				if( i + j + k )
				{
					DWORD dwStateId = GetStateIdOf( i, j, k );
					m_lpdwIKnow[ dwStateId ] = InitializeHeightOf( i, j, k );
//wsprintf( str, "i.e. ( %u, %u, %u ) h=%u\n\n", i, j, k, m_lpdwIKnow[ dwStateId ] );
//_debug(str);
				}
			}
		}
	}
}

DWORD CDeepFish::InitializeHeightOf( DWORD a, DWORD b, DWORD c )
{
//TCHAR str[1000];
	if( a + b + c == 1U ) return 1U;
	else if( a + b + c == 0U ) return 0U;
	DWORD dwCurrentStateId = GetStateIdOf( a,b,c );
	/*
	DWORD a = GetA( dwCurrentStateId );
	DWORD b = GetB( dwCurrentStateId );
	DWORD c = GetC( dwCurrentStateId );*/
	DWORD dwOdd = 0UL;
	DWORD dwEven = 0UL;
	DWORD i;
	DWORD dwNextStateId;
	DWORD dwHeight;
	for( i = a - 1; i >= 0 && i < m_dwMin; i-- )
	{
		dwNextStateId = GetStateIdOf( i, b, c );
		if( dwNextStateId == 0UL || dwNextStateId == dwCurrentStateId ) continue;
		dwHeight = m_lpdwIKnow[ dwNextStateId ];
		if( dwHeight & 0x1 )
		{
			if( dwHeight < dwOdd || ! dwOdd ) dwOdd = dwHeight;
		}
		else
		{
			if( dwHeight > dwEven || ! dwEven ) dwEven = dwHeight;
		}
//wsprintf( str, " A %d,%d,%d h=%d", i, b, c, dwHeight );
//_debug(str);
	}

	for( i = b - 1; i >= 0 && i < m_dwMid; i-- )
	{
		dwNextStateId = GetStateIdOf( a, i, c );
		if( dwNextStateId == 0UL || dwNextStateId == dwCurrentStateId ) continue;
		dwHeight = m_lpdwIKnow[ dwNextStateId ];

		if( dwHeight & 0x1 )
		{
			if( dwHeight < dwOdd || ! dwOdd ) dwOdd = dwHeight;
		}
		else
		{
			if( dwHeight > dwEven || ! dwEven ) dwEven = dwHeight;
		}
//wsprintf( str, " B %d,%d,%d h=%d", a,i, c, dwHeight );
//_debug(str);
	}

	for( i = c - 1; i >= 0 && i < m_dwMax; i-- )
	{
		dwNextStateId = GetStateIdOf( a, b, i );
		if( dwNextStateId == 0UL || dwNextStateId == dwCurrentStateId ) continue;
		dwHeight = m_lpdwIKnow[ dwNextStateId ];
		if( dwHeight & 0x1 )
		{
			if( dwHeight < dwOdd || ! dwOdd ) dwOdd = dwHeight;
		}
		else
		{
			if( dwHeight > dwEven || ! dwEven ) dwEven = dwHeight;
		}
//wsprintf( str, " C %d,%d,%d h=%d", a, b, i, dwHeight );
//_debug(str);
	}

	return ( dwOdd )? dwOdd + 1: dwEven + 1 ;
}


CDeepFish::~CDeepFish()
{
//	_debug( "~CDeepFish" );
	delete [] m_lpdwIKnow;
}

DWORD CDeepFish::GetNextStateOf( const DWORD a, const DWORD b, const DWORD c )
{
//TCHAR str[1000];
//wsprintf( str, "GetNextStateOf( %u, %u, %u )...", a, b, c );
//_debug(str);
	
	const DWORD dwCurrentStateId = GetStateIdOf( a, b, c );
	if( dwCurrentStateId > m_dwSize ) return 0UL;
//_debug("test 1");

	const DWORD dwCurrentHeight = m_lpdwIKnow[ dwCurrentStateId ];

	if( dwCurrentHeight <= 1UL ) return 0UL;
//_debug("test 2");

	const DWORD dwTargetHeight = dwCurrentHeight - 1U;


	DWORD i;
	//DWORD h;
	DWORD dwStateId; // next state candidate
	for( i = a - 1U; m_a > i && i >= 0; i-- )
	{
			dwStateId = GetStateIdOf( i, b, c );

//wsprintf( str, " A %u %u %u, h=%d", i, b, c,m_lpdwIKnow[ dwStateId ] );
//_debug(str);
			if( dwStateId == 0UL || dwStateId == dwCurrentStateId ) continue;
			else if( dwTargetHeight == m_lpdwIKnow[ dwStateId ] ) return GetStateOf( i, b, c );
	}

	if( b > 0U )
	{
	for( i = b - 1U; m_b > i && i >= 0; i-- )
	{
		dwStateId = GetStateIdOf( a, i, c );

//wsprintf( str, " B %u %u %u, h=%d", a,i, c,m_lpdwIKnow[ dwStateId ] );
//_debug(str);
		
		if( dwStateId == 0UL || dwStateId == dwCurrentStateId ) continue;
		else if( dwTargetHeight == m_lpdwIKnow[ dwStateId ] ) return GetStateOf( a, i, c );
	}
	}

	if( c > 0U )
	{
	for( i = c - 1; m_c > i && i >= 0; i-- )
	{
		dwStateId = GetStateIdOf( a, b, i );
//wsprintf( str, " C %u %u %u, h=%d", a, b, i,m_lpdwIKnow[ dwStateId ] );
//_debug(str);

		if( dwStateId == 0UL || dwStateId == dwCurrentStateId ) continue;
		else if( dwTargetHeight == m_lpdwIKnow[ dwStateId ] ) return GetStateOf( a, b, i );
	}
	}

	return 0UL;
}
