// stdafx.h : include file for standard system include files,
//  or project specific include files that are used frequently, but
//      are changed infrequently
//

#if !defined(AFX_STDAFX_H__A9DB83DB_A9FD_11D0_BFD1_444553540000__INCLUDED_)
#define AFX_STDAFX_H__A9DB83DB_A9FD_11D0_BFD1_444553540000__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#define WIN32_LEAN_AND_MEAN		// Exclude rarely-used stuff from Windows headers


// Windows Header Files:
#include <windows.h>


#include <commctrl.h>

// C RunTime Header Files
#include <stdlib.h>
#include <malloc.h>
#include <memory.h>
#include <tchar.h>

// Local Header Files
#define WM_DEEPFISH WM_USER + 1
#define APP_NAME TEXT( "Deep Fish v0.3-alpha" )

// TODO: reference additional headers your program requires here
HFONT GetMyFont( int iSize, BOOL bBold );
DWORD _hit( int x, int y, int a, int b, int c );
void _unselecta( HWND hWnd, LPINT lp );
void _unselectb( HWND hWnd, LPINT lp );
void _unselectc( HWND hWnd, LPINT lp );
LRESULT CALLBACK WndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam);

LRESULT CALLBACK About(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam);
class CDeepFish
{
	public:
		DWORD GetHeightOf( DWORD dwState )
		{ 
			return m_lpdwIKnow[ dwState ];
		};
		DWORD GetHeightOf( UINT a, UINT b, UINT c )
		{
			if( a > m_a || b > m_b || c > m_c ) return 0UL;
			return m_lpdwIKnow[ GetStateIdOf( a, b, c ) ];
		};

		DWORD GetA( DWORD dwState )
		{
			return ( dwState & 0x00ff0000 ) >> 16;
		};
		DWORD GetB( DWORD dwState )
		{
			return ( dwState & 0x0000ff00 ) >> 8;
		};
		DWORD GetC( DWORD dwState )
		{
			return ( dwState & 0x000000ff );
		};

/*
	int c = dwCurrentState % ( m_c + 1 );
	int tmp = dwCurrentState / ( m_c + 1 );
	int b = tmp % ( m_b + 1 );
	int a = tmp / ( m_b + 1 );

  */
//		DWORD GetNextStateOf( DWORD dwCurrentState );
		DWORD GetNextStateOf( DWORD a, DWORD b, DWORD c );
	private:
		DWORD m_a, m_b, m_c;
		DWORD m_dwMax, m_dwMid, m_dwMin;
		DWORD m_dwSize;
		DWORD * m_lpdwIKnow;

		DWORD GetStateOf( DWORD a, DWORD b, DWORD c ) // not normalized
		{
			return ( a << 16 ) | ( b << 8 ) | c;
		};

		DWORD GetStateIdOf( UINT a, UINT b, UINT c ) // normalized
		{
			DWORD uMin = Min( a, b, c );
			DWORD uMid = Mid( a, b, c );
			DWORD uMax = Max( a, b, c );
			return ( uMin * ( m_dwMid + 1 ) * ( m_dwMax + 1 ) + uMid * ( m_dwMax + 1 ) + uMax );
		};
		DWORD Min( DWORD x, DWORD y, DWORD z )
		{
			return min( x, min( y, z ) );
		};
		DWORD Mid( DWORD x, DWORD y, DWORD z )
		{
			DWORD dwMax = Max( x, y, z );
			return dwMax == x ? max( y, z ) : dwMax == y ? max( z, x ) : max( x, y ) ;
		};
		DWORD Max( DWORD x, DWORD y, DWORD z )
		{
			return max( x, max( y, z ) );
		};
		DWORD InitializeHeightOf( DWORD a, DWORD b, DWORD c );

	public:
		~CDeepFish();

		CDeepFish( UINT a, UINT b, UINT c );

};

#ifdef _DEBUG
#define _debug( str ) {\
	FILE * _debug_fp = fopen( "debug.txt", "a" );\
	fprintf( _debug_fp, "%s\n", str );\
	fclose( _debug_fp );\
}
#else
#define _debug( str )
#endif

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_STDAFX_H__A9DB83DB_A9FD_11D0_BFD1_444553540000__INCLUDED_)
