#include "stdafx.h"
#include "resource.h"
#include <stdio.h>

DWORD init_a = 3, init_b = 5, init_c = 7;



LRESULT CALLBACK WndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	static CDeepFish * lpDeepFish;
	
	int wmId, wmEvent;

	static HWND hStart, hOk, hReset, hSB;
	static HFONT hBtnFont;
	static HCURSOR hCursor[ 2 ];

	
	static DWORD a,b,c;
	static int a_selected[ 32 ];
	static int b_selected[ 32 ];
	static int c_selected[ 32 ];

	static int nMove = 1;
	static int bMyTurn = TRUE;

	switch (message) 
	{
		case WM_CREATE:
		{
			HINSTANCE hInst = (HINSTANCE) GetWindowLong( hWnd, GWL_HINSTANCE );
			hReset = CreateWindow( TEXT( "BUTTON" ), TEXT( "Reset" ), 
				WS_CHILD | WS_VISIBLE | BS_PUSHBUTTON,
				120,520,140,50,
				hWnd, (HMENU)IDM_RESET, hInst, NULL );
			hOk = CreateWindow( TEXT( "BUTTON" ), TEXT( "OK" ), 
				WS_CHILD | WS_VISIBLE | BS_PUSHBUTTON,
				270,520,140,50,
				hWnd, (HMENU)IDM_OK, hInst, NULL );
			hStart = CreateWindow( TEXT( "BUTTON" ), TEXT( "Start" ), 
				WS_CHILD | WS_VISIBLE | BS_PUSHBUTTON,
				420,520,140,50,
				hWnd, (HMENU)IDM_START, hInst, NULL );

			hSB = CreateWindow(
				STATUSCLASSNAME,
				NULL,
				WS_CHILD | SBARS_SIZEGRIP | CCS_BOTTOM | WS_VISIBLE,
				CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT,
				hWnd,
				(HMENU) 1,
				hInst,
				NULL
			);

			hBtnFont = GetMyFont( 24, FALSE );

			SendMessage( hStart, WM_SETFONT, ( WPARAM ) hBtnFont, 0L );
			SendMessage( hOk, WM_SETFONT, ( WPARAM ) hBtnFont, 0L );
			SendMessage( hReset, WM_SETFONT, ( WPARAM ) hBtnFont, 0L );
			EnableWindow( hStart, TRUE );
			EnableWindow( hOk, FALSE );
			EnableWindow( hReset, FALSE );
			HMENU hMenu = GetMenu( hWnd );
			EnableMenuItem( hMenu, IDM_OK, MF_GRAYED | MF_BYCOMMAND );
			EnableMenuItem( hMenu, IDM_RESET, MF_GRAYED | MF_BYCOMMAND );
			SetWindowText( hWnd, APP_NAME );



			a = init_a, b = init_b, c = init_c;

			LARGE_INTEGER liFrequency;
			LARGE_INTEGER liCount1, liCount2;
			BOOL bTimer = QueryPerformanceFrequency( &liFrequency );
			QueryPerformanceCounter( &liCount1 );

			lpDeepFish = new CDeepFish( a, b, c );
			QueryPerformanceCounter( &liCount2 );

			if( bTimer )
			{
				TCHAR szText[ 100 ];
				_stprintf( szText,
					TEXT( "%s : ( %d, %d, %d ) initialized in %.2f milliseconds" ),
					APP_NAME,
					a, b, c,
					( liCount2.LowPart - liCount1.LowPart ) * 1000.0 / (double)	liFrequency.LowPart
				);

				SendMessage( hSB, SB_SETTEXT, 0, (LPARAM) szText );
			}

			hCursor[ 0 ] = LoadCursor( (HINSTANCE) NULL, IDC_ARROW );
			hCursor[ 1 ] = LoadCursor( (HINSTANCE) NULL, IDC_HAND );
			SetCursor( hCursor[ 0 ] );
			break;
		}
		case WM_COMMAND:
			wmId    = LOWORD(wParam); 
			wmEvent = HIWORD(wParam); 
			// Parse the menu selections:
			switch (wmId)
			{
				case IDM_START:
				{
					int response = MessageBox(
						hWnd,
						TEXT("Do you want to move first?"),
						APP_NAME,
						MB_YESNO | MB_ICONQUESTION
					);

					EnableWindow( hStart, FALSE );
					EnableWindow( hOk, TRUE );
					EnableWindow( hReset, TRUE );
					HMENU hMenu = GetMenu( hWnd );
					EnableMenuItem( hMenu, IDM_START, MF_GRAYED | MF_BYCOMMAND );
					EnableMenuItem( hMenu, IDM_OK, MF_ENABLED | MF_BYCOMMAND );
					EnableMenuItem( hMenu, IDM_RESET, MF_ENABLED | MF_BYCOMMAND );
					
					if( response == IDYES )
					{
						TCHAR str[ 1000 ];
						bMyTurn = FALSE;
						wsprintf( str, TEXT("%s - [ * Your Turn * ]"), APP_NAME );
						SetWindowText( hWnd, str );
					}
					else
					{
						bMyTurn = TRUE;
						EnableMenuItem( GetMenu( hWnd ), IDM_OK, MF_GRAYED | MF_BYCOMMAND );
						EnableWindow( hOk, FALSE );
						SendMessage( hWnd, WM_DEEPFISH, 0, 0 );
					}
					break;
				}
				case IDM_RESET:
				{

					SYSTEMTIME st;
					GetSystemTime( &st );
					UINT uSeed = ( st.wMinute * 60 + st.wSecond ) * 1000 + st.wMilliseconds;
					srand( uSeed );
					init_a = ( (DWORD) rand() ) % 7 + 10;
					do
					{
						init_b = ( (DWORD) rand() ) % 7 + 10;
					} while( init_b == init_a );
					do
					{
						init_c = ( (DWORD) rand() ) % 7 + 10;
					} while( init_c == init_a || init_c == init_b );

					a = init_a;
					b = init_b;
					c = init_c;

					delete lpDeepFish;
					LARGE_INTEGER liFrequency;
					LARGE_INTEGER liCount1, liCount2;
					BOOL bTimer = QueryPerformanceFrequency( &liFrequency );
					QueryPerformanceCounter( &liCount1 );
					
					lpDeepFish = new CDeepFish( a, b, c );

					QueryPerformanceCounter( &liCount2 );

					nMove = 1;
					EnableWindow( hStart, TRUE );
					EnableWindow( hOk, FALSE );
					EnableWindow( hReset, FALSE );
					HMENU hMenu = GetMenu( hWnd );
					EnableMenuItem( hMenu, IDM_START, MF_ENABLED | MF_BYCOMMAND );
					EnableMenuItem( hMenu, IDM_OK, MF_GRAYED | MF_BYCOMMAND );
					EnableMenuItem( hMenu, IDM_RESET, MF_GRAYED | MF_BYCOMMAND );
					_unselecta( hWnd, a_selected );
					_unselectb( hWnd, b_selected );
					_unselectc( hWnd, c_selected );
					bMyTurn = TRUE;
					SetWindowText( hWnd, APP_NAME );
					InvalidateRect( hWnd, NULL, TRUE );
					//TCHAR szText[ 100 ];
					//wsprintf( szText, TEXT( "Current height = %d" ), lpDeepFish->GetHeightOf( a, b, c ) );
					if( bTimer )
					{
						TCHAR szText[ 100 ];
						_stprintf( szText,
							TEXT( "%s : ( %d, %d, %d ) initialized in %.2f milliseconds." ),
							APP_NAME,
							a, b, c,
							( liCount2.LowPart - liCount1.LowPart ) * 1000.0 / (double)	liFrequency.LowPart
						);
						SendMessage( hSB, SB_SETTEXT, 0, (LPARAM) szText );
					}
						else SendMessage( hSB, SB_SETTEXT, 0, (LPARAM) TEXT( "" ) );
					break;
				}
				case IDM_OK:
				{
					if( bMyTurn ) break;
					if( a + b + c == 0 )
					{
						MessageBox( hWnd, TEXT("Unselect one or more stones."), TEXT("No stones unselected"), MB_OK | MB_ICONEXCLAMATION );
						break;
					}
					if( a + b + c == 1 )
					{
						MessageBox( hWnd, TEXT("You lost :P"), APP_NAME, MB_OK | MB_ICONINFORMATION );
						break;
					}
					DWORD i;
					DWORD olda =a, oldb = b, oldc = c;
					for( i = 0; i < init_a; i++ ) if( a_selected[ i ] ) a--;
					for( i = 0; i < init_b; i++ ) if( b_selected[ i ] ) b--;
					for( i = 0; i < init_c; i++ ) if( c_selected[ i ] ) c--;
					if( olda == a && oldb == b && oldc == c )
					{
						MessageBox( hWnd, TEXT("Select one or more stones."), TEXT("No stones selected"), MB_OK | MB_ICONEXCLAMATION );
						break;
					}
					_unselecta( hWnd, a_selected );
					_unselectb( hWnd, b_selected );
					_unselectc( hWnd, c_selected );
					SetWindowText( hWnd, APP_NAME );

					nMove++;
					bMyTurn = TRUE;
					EnableMenuItem( GetMenu( hWnd ), IDM_OK, MF_GRAYED | MF_BYCOMMAND );
					EnableWindow( hOk, FALSE );
#ifdef _DEBUG
					TCHAR szText[ 100 ];
					wsprintf( szText, TEXT( "Current height = %d" ), lpDeepFish->GetHeightOf( a, b, c ) );
					SendMessage( hSB, SB_SETTEXT, 0, (LPARAM) szText );
#endif
					SendMessage( hWnd, WM_DEEPFISH, 0, 0 );
					break;
				}
				case IDM_ABOUT:
				   DialogBox((HINSTANCE) GetWindowLong( hWnd, GWL_HINSTANCE ), (LPCTSTR)IDD_ABOUTBOX, hWnd, (DLGPROC)About);
				   break;
				case IDM_EXIT:
				   DestroyWindow(hWnd);
				   break;
				default:
				   return DefWindowProc(hWnd, message, wParam, lParam);
			}
			break;
		case WM_PAINT:
		{
			POINT pt;
			GetCursorPos( &pt );
			ScreenToClient( hWnd, &pt );
			DWORD dw = ( bMyTurn )? 0UL : _hit( pt.x, pt.y, a, b, c );
			WORD wHitLine = HIWORD( dw );
			WORD wHitRow = LOWORD( dw );
			PAINTSTRUCT ps;
			HFONT hFont = GetMyFont( 48, TRUE );
			HDC hdc = BeginPaint(hWnd, &ps);
			HFONT hOldFont = (HFONT) SelectObject( hdc, hFont );
			DWORD i;
			SetBkMode( hdc, TRANSPARENT );
			SetTextColor( hdc, RGB( 0xcc, 0xcc, 0xff ) );

			TextOut( hdc, 30,  50, TEXT("A"), 1 );
			TextOut( hdc, 30, 200, TEXT("B"), 1 );
			TextOut( hdc, 30, 350, TEXT("C"), 1 );

			HBRUSH hBrush = (HBRUSH) CreateSolidBrush( RGB( 0xaa, 0xee, 0xee ) );
			HBRUSH hBrushHover = (HBRUSH) CreateSolidBrush( RGB( 0xff, 0xcc, 0xee ) );
			HBRUSH hBrushSel = (HBRUSH) CreateSolidBrush( RGB( 0xff, 0xcc, 0x66 ) );
			HBRUSH hOldBrush = (HBRUSH) SelectObject( hdc, hBrush );
			int x = 100;
			int y = 50;
			for( i = 0; i < a; i++ )
			{
				if( a_selected[ i ] ) SelectObject( hdc, hBrushSel );
				else if( wHitLine == 1 && wHitRow == i ) SelectObject( hdc, hBrushHover );
				else SelectObject( hdc, hBrush );

				if( i == 8 ) { x = 100; y += 60; }

				Ellipse( hdc, x, y, x+50, y+50 );
				x+=70;
			}
			if( i <= 8 ) y += 60;

			x = 100;
			y += 90;


			for( i = 0; i < b; i++ )
			{
				if( b_selected[ i ] ) SelectObject( hdc, hBrushSel );
				else if( wHitLine == 2 && wHitRow == i ) SelectObject( hdc, hBrushHover );
				else SelectObject( hdc, hBrush );
				if( i == 8 ) { x = 100; y += 60; }
				Ellipse( hdc, x, y, x+50, y+50 );
				x+=70;
			}
			if( i <= 8 ) y += 60;
			x = 100;
			y += 90;
			for( i = 0; i < c; i++ )
			{
				if( c_selected[ i ] ) SelectObject( hdc, hBrushSel );
				else if( wHitLine == 3 && wHitRow == i ) SelectObject( hdc, hBrushHover );
				else SelectObject( hdc, hBrush );
				if( i == 8 ) { x = 100; y += 60; }
				Ellipse( hdc, x, y, x+50, y+50 );
				x+=70;
			}

			SelectObject( hdc, hOldFont );
			DeleteObject( hFont );

			SelectObject( hdc, hOldBrush );
			DeleteObject( hBrush );
			DeleteObject( hBrushHover );
			DeleteObject( hBrushSel );


			EndPaint(hWnd, &ps);
			break;
		}
		case WM_LBUTTONDOWN:
		{
			if( bMyTurn ) break;
			///***
			int cursor_x = (int) LOWORD(lParam); 
			int cursor_y = (int) HIWORD(lParam); 
			DWORD dwHit = _hit( cursor_x, cursor_y, a, b, c );
			if( !dwHit ) break;

			WORD wLine = HIWORD( dwHit );
			WORD wRaw = LOWORD( dwHit );
			if( wLine == 1 && wRaw < init_a )
			{
				_unselectb( hWnd, b_selected );
				_unselectc( hWnd, c_selected );
				a_selected[ wRaw ] = ! a_selected[ wRaw ];
			}
			else if( wLine == 2 && wRaw < init_b )
			{
				_unselectc( hWnd, c_selected );
				_unselecta( hWnd, a_selected );
				b_selected[ wRaw ] = ! b_selected[ wRaw ];
			}
			else if( wLine == 3 && wRaw < init_c )
			{
				_unselecta( hWnd, a_selected );
				_unselectb( hWnd, b_selected );
				c_selected[ wRaw ] = ! c_selected[ wRaw ];
			}
			RECT rect;
			rect.top = 50 + 150 * ( wLine - 1 );
			if( wRaw >= 8 ) { rect.top += 60; wRaw -= 8; }
			rect.bottom = rect.top + 50;
			rect.left = 100 + wRaw * 70;
			rect.right = rect.left + 50;
			InvalidateRect( hWnd, &rect, TRUE );

			break;
		}
		case WM_MOUSEMOVE:
		{
			if( bMyTurn ) break;
			///***

			static DWORD dwOldHit = 0UL;
			RECT rect = { 0, 0, 0, 0 };
			int x = (int) LOWORD(lParam); 
			int y = (int) HIWORD(lParam); 
#ifdef _DEBUG
//			TCHAR szText[ 100 ];
//			wsprintf( szText, TEXT( "x=%d y=%d" ), x,y );
//			SendMessage( hSB, SB_SETTEXT, 0, (LPARAM) szText );
#endif

			
			DWORD dwHit = _hit( x, y, a, b, c );
			WORD wLine = HIWORD( dwHit );
			WORD wRaw = LOWORD( dwHit );
			WORD wOldLine = HIWORD( dwOldHit );
			WORD wOldRaw = LOWORD( dwOldHit );
			SetCursor( hCursor[ !!( dwHit ) ] );
			if( wLine == wOldLine && wRaw == wOldRaw ) break;
			if( dwHit )
			{
				
				dwOldHit = dwHit;
				rect.top = 50 + 150 * ( wLine - 1 );
				if( wRaw >= 8 ) { rect.top += 60; wRaw -= 8; }
				rect.bottom = rect.top + 50;
				rect.left = 100 + wRaw * 70;
				rect.right = rect.left + 50;
				InvalidateRect( hWnd, &rect, TRUE );
			}
			else if( dwOldHit )
			{
				dwOldHit = 0UL;
				rect.top = 50 + 150 * ( wOldLine - 1 );
				if( wOldRaw >= 8 ) { rect.top += 60; wOldRaw -= 8; }
				rect.bottom = rect.top + 50;
				rect.left = 100 + wOldRaw * 70;
				rect.right = rect.left + 50;
				InvalidateRect( hWnd, &rect, TRUE );
			}
			break;
		}

		case WM_DEEPFISH:
		{
			TCHAR str[1000];
					InvalidateRect( hWnd, NULL, TRUE );
			if( ! bMyTurn ) break;

					if( a + b + c == 1 )
					{
						MessageBox( hWnd, TEXT("I lost ;_;"), APP_NAME, MB_OK | MB_ICONINFORMATION );
						break;
					}

			DWORD nextA = 0, nextB = 0, nextC = 0;

			DWORD dwNextState = lpDeepFish->GetNextStateOf( a, b, c );
			if( dwNextState )
			{
				nextA = lpDeepFish->GetA( dwNextState );
				nextB = lpDeepFish->GetB( dwNextState );
				nextC = lpDeepFish->GetC( dwNextState );
			

						TCHAR szFrom[ 10 ] = TEXT( "<error>" );
						int number = 0;
						if( a != nextA )
						{
							number = a - nextA;
							lstrcpy( szFrom, TEXT( "A" ) );
						}
						else if( b != nextB )
						{
							number = b - nextB;
							lstrcpy( szFrom, TEXT( "B" ) );
						}
						else if( c != nextC )
						{
							number = c - nextC;
							lstrcpy( szFrom, TEXT( "C" ) );
						}

						wsprintf( str, TEXT( "I will take %d stone%s from %s..." ), 
							number,
							number > 1? TEXT("s"):TEXT(""),
							szFrom
						);
						MessageBox( hWnd, str, APP_NAME, MB_OK | MB_ICONINFORMATION );
						a = nextA, b = nextB, c = nextC;
						nMove++;
					bMyTurn = FALSE;
					EnableMenuItem( GetMenu( hWnd ), IDM_OK, MF_ENABLED | MF_BYCOMMAND );
					EnableWindow( hOk, TRUE );
					wsprintf( str, TEXT("%s - [ * Your Turn * ]"), APP_NAME );
					SetWindowText( hWnd, str );
					InvalidateRect( hWnd, NULL, TRUE );
#ifdef _DEBUG
					TCHAR szText[ 100 ];
					wsprintf( szText, TEXT( "Current height = %d" ), lpDeepFish->GetHeightOf( a, b, c ) );
					SendMessage( hSB, SB_SETTEXT, 0, (LPARAM) szText );
#endif
			}
			else
			{
				MessageBox( hWnd, TEXT( "Oops..." ), APP_NAME, MB_OK | MB_ICONSTOP );
			}
			break;
		}
		case WM_SIZE:
				SendMessage( hSB, WM_SIZE, 0U, 0L );
				break;
		case WM_DESTROY:
			DeleteObject( hBtnFont );
			delete lpDeepFish;
			PostQuitMessage(0);
			break;
		default:
			return DefWindowProc(hWnd, message, wParam, lParam);
   }
   return 0;
}


